from transitions import Machine

import component_connector


class Buttons:
    states = ['ayy', 'bee', 'cee']
    transitions = [
        {'trigger': 'anchor_a', 'source': 'ayy', 'dest': 'bee'},
        {'trigger': 'anchor_b', 'source': 'bee', 'dest': 'cee'},
        {'trigger': 'anchor_c', 'source': 'cee', 'dest': 'ayy'},
    ]

    def __init__(self):
        self.machine = Machine(model=self,
                               states=Buttons.states,
                               transitions=Buttons.transitions,
                               initial='ayy',
                               send_event=True,
                               ignore_invalid_triggers=True,
                               after_state_change='forward_message')

    def forward_message(self, event_data):
        message = event_data.kwargs.get('message')
        component_connector.send_message(message)


fsm = Buttons()