import json
from functools import partial

from component_base import ComponentBase


class Component(ComponentBase):
    def __init__(self, anchor, event_handler, zmq_context=None):
        super().__init__(anchor, event_handler, zmq_context)

        def wrapper(msg_parts, handler):
            anchor, message = msg_parts
            data_json = json.loads(message)
            response = handler(data_json, self)
            encoded_response = json.dumps(response).encode('utf-8')
            self.zmq_push_socket.send_multipart([anchor, encoded_response])

        self.zmq_sub_stream.on_recv(partial(wrapper, handler=event_handler))


